#ifndef INC_GTIMAGE_H
#define INC_GTIMAGE_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "gtbase.h"
#include "gtdisplay.h"
#include "gtdrawable.h"
#include "gtgc.h"

/************************************************************************\
*
* GtImage class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/


class GtImage : public GtBase
{
public:
		/* Standard */
	GtImage(void);
	void Destroy(void);
	sbool Init(GtDisplay *d,GtTag *tgs);
	sbool Init(GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
  char *GetClass(void) { return("GtImage"); }
  sbool IsSubClassOf(char *cn);
		/* Pixel management */
	inline void PutPixel(int xp,int yp,ulong pixel) { XPutPixel(im,xp,yp,pixel); }
	inline ulong GetPixel(int xp,int yp) { return(XGetPixel(im,xp,yp)); }
	inline void AddPixel(long value) { XAddPixel(im,value); }
		/* Get/Put image */
	void PutImage(GtDrawable *dr,GtGC *gc,int sx,int sy,int dx,int dy,
								int xs,int ys);
	void GetImage(GtDrawable *dr,int sx,int sy,int xs,int ys,ulong msk,
								int fmt,int dx,int dy);
		/* Values */
	inline int GetCompletionType(void) { return(comptype); }
	inline char *GetData(void) { return(data); }
	inline int GetBytesPerLine(void) { return(im->bytes_per_line); }
	inline XImage *XIm(void) { return(im); }
protected:
	GtDisplay *dsp;
	XImage *im;
	char *data;
	int comptype;
	ubyte flags;
	sbool send;
	void *sinfo;
};

extern GtImage *GtMkImage(GtDisplay *d,GtTag *tgs);
extern GtImage *GtMkImage(GtDisplay *d,ulong tag,...);

extern sbool GtShmSupport(void);

#endif /* INC_GTIMAGE_H */
